import { Upload } from 'element-ui'

const uploadC = Upload.components['Upload']

export default {
  name: 'ZkUpload',
  extends: Upload,
  render() {
    let uploadList
    if (this.showFileList) {
      uploadList = (
        <UploadList disabled={this.uploadDisabled} listType={this.listType} files={this.uploadFiles} on-remove={this.handleRemove} handlePreview={this.onPreview}>
          {(props) => {
            if (this.$scopedSlots.file) {
              return this.$scopedSlots.file({
                file: props.file,
              })
            }
          }}
        </UploadList>
      )
    }
    const uploadData = {
      props: {
        type: this.type,
        drag: this.drag,
        action: this.action,
        multiple: this.multiple,
        'before-upload': this.beforeUpload,
        'with-credentials': this.withCredentials,
        headers: this.headers,
        name: this.name,
        data: this.data,
        accept: this.accept,
        fileList: this.uploadFiles,
        autoUpload: this.autoUpload,
        listType: this.listType,
        disabled: this.uploadDisabled,
        limit: this.limit,
        'on-exceed': this.onExceed,
        'on-start': this.handleStart,
        'on-progress': this.handleProgress,
        'on-success': this.handleSuccess,
        'on-error': this.handleError,
        'on-preview': this.onPreview,
        'on-remove': this.handleRemove,
        'http-request': this.httpRequest,
      },
      ref: 'upload-inner',
      class: this.uploadFiles.length >= this.limit && 'limited',
    }
    const trigger = this.$slots.trigger || this.$slots.default
    const uploadComponent = <uploadC {...uploadData}>{trigger}</uploadC>
    return (
      <div>
        {this.listType === 'picture-card' ? uploadList : ''}
        {this.$slots.trigger ? [uploadComponent, this.$slots.default] : uploadComponent}
        {this.fileList.length >= this.limit ? null : this.$slots.tip}
        {this.listType !== 'picture-card' ? uploadList : ''}
      </div>
    )
  },
}
