import Select from './components/select'
import Spin from './components/spin'
import Table from './components/table'
import Form from './components/form'
import CheckboxGroup from './components/checkbox-group'
import RadioGroup from './components/radio-group'
import Upload from './components/upload'
import RichText from './components/rich-text'
import Cascader from './components/cascader'
import Layout from './components/layout'
import SvgIcon from './components/svg'

const components = [Select, Spin, Table, Form, CheckboxGroup, RadioGroup, Upload, RichText, Cascader, Layout, SvgIcon]

function install(Vue) {
  if (install.installed) return
  components.forEach((component) => {
    Vue.component(component.name, component)
  })
}

/* istanbul ignore if */
if (typeof window !== 'undefined' && window.Vue) {
  window.Vue.use(install)
}

export default {
  install,
  Select,
  Spin,
  Table,
  Form,
  CheckboxGroup,
  RadioGroup,
  Upload,
  RichText,
  Cascader,
  Layout,
  SvgIcon,
}
